include "basics/pts.ma".
axiom eq : \forall A : Type[0] . A -> A -> Prop.
axiom refl : \forall A. \forall (x:A). (eq) (A) x x.
axiom eq_ind : \forall A. \forall (x:A). \forall (P:A -> Prop). (P x) -> \forall (y:A). ((eq) (A) x y) -> P y.
definition eq_rect_r : \forall A. \forall (a:A). \forall (x:A). ((eq) (A) x a) -> \forall (P:A -> Prop). (P a) -> P x := \lambda A : Type[0]. \lambda a : A. \lambda x : A. \lambda p : (eq) (A) x a. (((((((eq_ind) (A)) (x)) (\lambda j__ : A. \forall (P:A -> Prop). (P j__) -> P x)) (\lambda P : A -> Prop. \lambda auto : P x. (auto))) (a)) (p)).
definition eq_ind_r : \forall A. \forall (a:A). \forall (P:A -> Prop). (P a) -> \forall (x:A). ((eq) (A) x a) -> P x := \lambda A : Type[0]. \lambda a : A. \lambda P : A -> Prop. \lambda p : P a. (\lambda x0 : A. \lambda p0 : (eq) (A) x0 a. (((((((eq_rect_r) (A)) (a)) (x0)) (p0)) (\lambda x01 : A. P x01)) (p))).
definition rewrite_l : \forall A. \forall (x:A). \forall (P:A -> Prop). (P x) -> \forall (y:A). ((eq) (A) x y) -> P y := \lambda A : Type[0]. \lambda x : A. \lambda P : A -> Prop. \lambda Hx : P x. (\lambda y : A. \lambda Heq : (eq) (A) x y. (((((((eq_ind) (A)) (x)) (\lambda j__ : A. P j__)) (Hx)) (y)) (Heq))).
definition eq_f2 : \forall A. \forall B. \forall C. \forall (f:A -> B -> C). \forall (x1:A). \forall (x2:A). \forall (y1:B). \forall (y2:B). ((eq) (A) x1 x2) -> ((eq) (B) y1 y2) -> (eq) (C) (f x1 y1) (f x2 y2) := \lambda A : Type[0]. \lambda B : Type[0]. \lambda C : Type[0]. \lambda f : A -> B -> C. \lambda x1 : A. \lambda x2 : A. \lambda y1 : B. \lambda y2 : B. \lambda E1 : (eq) (A) x1 x2. (\lambda E2 : (eq) (B) y1 y2. (((((((eq_ind_r) (A)) (x2)) (\lambda x : A. (eq) (C) (f x y1) (f x2 y2))) (((((((eq_ind_r) (B)) (y2)) (\lambda x : B. (eq) (C) (f x2 x) (f x2 y2))) (((((((rewrite_l) (A)) (x1)) (\lambda j__ : A. (eq) (C) (f j__ y2) (f x2 y2))) (((((((rewrite_l) (B)) (y1)) (\lambda j__ : B. (eq) (C) (f x1 j__) (f x2 y2))) (((((((rewrite_l) (A)) (x1)) (\lambda j__ : A. (eq) (C) (f x1 y1) (f j__ y2))) (((((((rewrite_l) (B)) (y1)) (\lambda j__ : B. (eq) (C) (f x1 y1) (f x1 j__))) (((refl) (C)) (f x1 y1))) (y2)) (E2))) (x2)) (E1))) (y2)) (E2))) (x2)) (E1))) (y1)) (E2))) (x1)) (E1))).
